# ntw-processor

Group your functions into a network and process values

## Installation

Using npm:

    $ npm i --save ntw-processor

In Node.js:

    const NtwProcessor = require('ntw-processor');

## Usage

Linear network:

    // Create some functions
    const a = elem => ++elem;
    const b = elem => elem * 3;
    const c = elem => elem / 2;

    // Instanciate the processor as an array of functions
    const processor = new NtwProcessor([a, b, c]);

    // Start processing
    const input = 1;
    processor.init(input).subscribe(output => {
        // Expected output: 3
        console.log(output);
    });

Non linear network:

    // Create some functions
    const a = elem => ++elem;
    const b = elem => elem * 3;
    const c = elem => elem / 2;

    // Instanciate the processor as an array of config objects
    const processor = new NtwProcessor([
        { id: 0, fn: a, next: [1, 2] },
        { id: 1, fn: b },
        { id: 2, fn: c }
    ]);

    // Start processing
    const input = 1;
    processor.init(input).subscribe(output => {
        // Expected output: [6, 1]
        console.log(output);
    });
